# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Appconfiguration::Mgmt::V2019_11_01_preview
  module Models
    #
    # An identity that can be associated with a resource.
    #
    class ResourceIdentity

      include MsRestAzure

      # @return [IdentityType] The type of managed identity used. The type
      # 'SystemAssigned, UserAssigned' includes both an implicitly created
      # identity and a set of user-assigned identities. The type 'None' will
      # remove any identities. Possible values include: 'None',
      # 'SystemAssigned', 'UserAssigned', 'SystemAssigned, UserAssigned'
      attr_accessor :type

      # @return [Hash{String => UserIdentity}] The list of user-assigned
      # identities associated with the resource. The user-assigned identity
      # dictionary keys will be ARM resource ids in the form:
      # '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}'.
      attr_accessor :user_assigned_identities

      # @return [String] The principal id of the identity. This property will
      # only be provided for a system-assigned identity.
      attr_accessor :principal_id

      # @return [String] The tenant id associated with the resource's identity.
      # This property will only be provided for a system-assigned identity.
      attr_accessor :tenant_id


      #
      # Mapper for ResourceIdentity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ResourceIdentity',
          type: {
            name: 'Composite',
            class_name: 'ResourceIdentity',
            model_properties: {
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              user_assigned_identities: {
                client_side_validation: true,
                required: false,
                serialized_name: 'userAssignedIdentities',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UserIdentityElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UserIdentity'
                      }
                  }
                }
              },
              principal_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'principalId',
                type: {
                  name: 'String'
                }
              },
              tenant_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tenantId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
